## com.sun.jersey.core.util
Class KeyComparatorHashMap<K,V>

    java.lang.Object
      java.util.AbstractMap<K,V>
          com.sun.jersey.core.util.KeyComparatorHashMap<K,V>

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, java.util.Map<K,V>

Direct Known Subclasses:
  KeyComparatorLinkedHashMap

    public class KeyComparatorHashMap<K,V>

extends java.util.AbstractMap<K,V>
implements java.util.Map<K,V>, java.lang.Cloneable, java.io.Serializable

A implementation similar to `HashMap` but supports the comparison of keys using a `KeyComparator`.

Author:
  Paul.Sandoz@Sun.Com
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class java.util.AbstractMap
`java.util.AbstractMap.SimpleEntry<K,V>, java.util.AbstractMap.SimpleImmutableEntry<K,V>`

Constructor Summary
`KeyComparatorHashMap(int initialCapacity, float loadFactor, KeyComparator<K> keyComparator)` Constructs an empty `HashMap` with the specified initial capacity and load factor.
`KeyComparatorHashMap(int initialCapacity, KeyComparator<K> keyComparator)` Constructs an empty `HashMap` with the specified initial capacity and the default load factor (0.75).
`KeyComparatorHashMap(KeyComparator<K> keyComparator)` Constructs an empty `HashMap` with the default initial capacity (16) and the default load factor (0.75).
`KeyComparatorHashMap(java.util.Map<? extends K,? extends V> m, KeyComparator<K> keyComparator)` Constructs a new `HashMap` with the same mappings as the specified `Map`.

Method Summary
`void` `clear()` Removes all mappings from this map.
`java.lang.Object` `clone()` Returns a shallow copy of this `HashMap` instance: the keys and values themselves are not cloned.
`boolean` `containsKey(java.lang.Object key)` Returns `true` if this map contains a mapping for the specified key.
`boolean` `containsValue(java.lang.Object value)` Returns `true` if this map maps one or more keys to the specified value.
`java.util.Set<java.util.Map.Entry<K,V>>` `entrySet()` Returns a collection view of the mappings contained in this map.
`V` `get(java.lang.Object key)` Returns the value to which the specified key is mapped in this identity hash map, or `null` if the map contains no mapping for this key.
`int` `getDEFAULT_INITIAL_CAPACITY()`
`int` `getModCount()` Get the number of times this HashMap has been structurally modified Structural modifications are those that change the number of mappings in the HashMap or otherwise modify its internal structure (e.g., rehash).
`boolean` `isEmpty()` Returns `true` if this map contains no key-value mappings.
`V` `put(K key, V value)` Associates the specified value with the specified key in this map.
`void` `putAll(java.util.Map<? extends K,? extends V> m)` Copies all of the mappings from the specified map to this map These mappings will replace any mappings that this map had for any of the keys currently in the specified map.
`V` `remove(java.lang.Object key)` Removes the mapping for this key from this map if present.
`int` `size()` Returns the number of key-value mappings in this map.

Methods inherited from class java.util.AbstractMap
`equals, hashCode, keySet, toString, values`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`equals, hashCode, keySet, values`

Constructor Detail

### KeyComparatorHashMap

    public KeyComparatorHashMap(int initialCapacity,
                                float loadFactor,
                                KeyComparator<K> keyComparator)

  Constructs an empty `HashMap` with the specified initial capacity and load factor.

  Parameters:
    `initialCapacity` - The initial capacity.
    `loadFactor` - The load factor.
  Throws:
    `java.lang.IllegalArgumentException` - if the initial capacity is negative or the load factor is nonpositive.

### KeyComparatorHashMap

    public KeyComparatorHashMap(int initialCapacity,
                                KeyComparator<K> keyComparator)

  Constructs an empty `HashMap` with the specified initial capacity and the default load factor (0.75).

  Parameters:
    `initialCapacity` - the initial capacity.
  Throws:
    `java.lang.IllegalArgumentException` - if the initial capacity is negative.

### KeyComparatorHashMap

    public KeyComparatorHashMap(KeyComparator<K> keyComparator)

  Constructs an empty `HashMap` with the default initial capacity (16) and the default load factor (0.75).

### KeyComparatorHashMap

    public KeyComparatorHashMap(java.util.Map<? extends K,? extends V> m,
                                KeyComparator<K> keyComparator)

  Constructs a new `HashMap` with the same mappings as the specified `Map`. The `HashMap` is created with default load factor (0.75) and an initial capacity sufficient to hold the mappings in the specified `Map`.

  Parameters:
    `m` - the map whose mappings are to be placed in this map.
  Throws:
    `java.lang.NullPointerException` - if the specified map is null.

Method Detail

### getDEFAULT_INITIAL_CAPACITY

    public int getDEFAULT_INITIAL_CAPACITY()

### getModCount

    public int getModCount()

  Get the number of times this HashMap has been structurally modified Structural modifications are those that change the number of mappings in the HashMap or otherwise modify its internal structure (e.g., rehash).

  Returns:
    return the modification count.

### size

    public int size()

  Returns the number of key-value mappings in this map.

  Specified by:
    `size` in interface `java.util.Map<K,V>`
  Overrides:
    `size` in class `java.util.AbstractMap<K,V>`
  Returns:
    the number of key-value mappings in this map.

### isEmpty

    public boolean isEmpty()

  Returns `true` if this map contains no key-value mappings.

  Specified by:
    `isEmpty` in interface `java.util.Map<K,V>`
  Overrides:
    `isEmpty` in class `java.util.AbstractMap<K,V>`
  Returns:
    `true` if this map contains no key-value mappings.

### get

    public V get(java.lang.Object key)

  Returns the value to which the specified key is mapped in this identity hash map, or `null` if the map contains no mapping for this key. A return value of `null` does not necessarily indicate that the map contains no mapping for the key; it is also possible that the map explicitly maps the key to `null`. The `containsKey` method may be used to distinguish these two cases.

  Specified by:
    `get` in interface `java.util.Map<K,V>`
  Overrides:
    `get` in class `java.util.AbstractMap<K,V>`
  Parameters:
    `key` - the key whose associated value is to be returned.
  Returns:
    the value to which this map maps the specified key, or `null` if the map contains no mapping for this key.
  See Also:
    `put(Object, Object)`

### containsKey

    public boolean containsKey(java.lang.Object key)

  Returns `true` if this map contains a mapping for the specified key.

  Specified by:
    `containsKey` in interface `java.util.Map<K,V>`
  Overrides:
    `containsKey` in class `java.util.AbstractMap<K,V>`
  Parameters:
    `key` - The key whose presence in this map is to be tested
  Returns:
    `true` if this map contains a mapping for the specified key.

### put

    public V put(K key,
                 V value)

  Associates the specified value with the specified key in this map. If the map previously contained a mapping for this key, the old value is replaced.

  Specified by:
    `put` in interface `java.util.Map<K,V>`
  Overrides:
    `put` in class `java.util.AbstractMap<K,V>`
  Parameters:
    `key` - key with which the specified value is to be associated.
    `value` - value to be associated with the specified key.
  Returns:
    previous value associated with specified key, or `null` if there was no mapping for key. A `null` return can also indicate that the HashMap previously associated `null` with the specified key.

### putAll

    public void putAll(java.util.Map<? extends K,? extends V> m)

  Copies all of the mappings from the specified map to this map These mappings will replace any mappings that this map had for any of the keys currently in the specified map.

  Specified by:
    `putAll` in interface `java.util.Map<K,V>`
  Overrides:
    `putAll` in class `java.util.AbstractMap<K,V>`
  Parameters:
    `m` - mappings to be stored in this map.
  Throws:
    `java.lang.NullPointerException` - if the specified map is null.

### remove

    public V remove(java.lang.Object key)

  Removes the mapping for this key from this map if present.

  Specified by:
    `remove` in interface `java.util.Map<K,V>`
  Overrides:
    `remove` in class `java.util.AbstractMap<K,V>`
  Parameters:
    `key` - key whose mapping is to be removed from the map.
  Returns:
    previous value associated with specified key, or `null` if there was no mapping for key. A `null` return can also indicate that the map previously associated `null` with the specified key.

### clear

    public void clear()

  Removes all mappings from this map.

  Specified by:
    `clear` in interface `java.util.Map<K,V>`
  Overrides:
    `clear` in class `java.util.AbstractMap<K,V>`

### containsValue

    public boolean containsValue(java.lang.Object value)

  Returns `true` if this map maps one or more keys to the specified value.

  Specified by:
    `containsValue` in interface `java.util.Map<K,V>`
  Overrides:
    `containsValue` in class `java.util.AbstractMap<K,V>`
  Parameters:
    `value` - value whose presence in this map is to be tested.
  Returns:
    `true` if this map maps one or more keys to the specified value.

### clone

    public java.lang.Object clone()

  Returns a shallow copy of this `HashMap` instance: the keys and values themselves are not cloned.

  Overrides:
    `clone` in class `java.util.AbstractMap<K,V>`
  Returns:
    a shallow copy of this map.

### entrySet

    public java.util.Set<java.util.Map.Entry<K,V>> entrySet()

  Returns a collection view of the mappings contained in this map. Each element in the returned collection is a `Map.Entry`. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. The collection supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

  Specified by:
    `entrySet` in interface `java.util.Map<K,V>`
  Specified by:
    `entrySet` in class `java.util.AbstractMap<K,V>`
  Returns:
    a collection view of the mappings contained in this map.

Copyright © 2017 Oracle Corporation. All Rights Reserved.